
########################
## REMOVE_PARENTHESES ##
########################



## My solution 

def remove_parentheses (s):
  new_s = ""
  is_paren_open = False
  for ch in s:
    if ch == '(':
      is_paren_open = True
    elif ch == ')':
      is_paren_open = False
    else:
      if is_paren_open == False:
        # only append characters to new_s
        # if the parentheses are not open
        new_s = new_s + ch
  return new_s



#########################
## STUDENT SUBMISSIONS ##
#########################



##########################################################################
# Q1:

def remove_parentheses (s):
  inparen=False
  new_string=""
  for i in range (len(s)):
  	if s[i] == "(" or s[i]== ")":
  		inparen = True
  	if not inparen:
  		new_string = new_string + s[i]
  	if s[i] == ")":
  		inparen = False
  return new_string

# A) this works as intended   <
# B) this does not work because it continues removing stuff after ")"
# C) this does not work for some other reason, but it runs
# D) this code does not run properly: there is a syntax mistake

# let's try ")hello": it works (it returns "hello")
# let's try "(hello": it's supposed to return "" and it does


##########################################################################
# Q2

def remove_parentheses (s):
    new_str=""
    para=False
    for c in s:
        if not para:
            if c.isalpha():
                new_str=new_str+c
            elif not c.isalpha():
                if c=="(":
                    para=True
                elif c!=")":
                    new_str=new_str+c
        elif para:
            if c==")":
                para=False
    return new_str

# A) this works as intended  <
# B) this does not work because ")hello(" will give "hello("
# C) this does not work because "(hello)there" will give "hello"
# D) this does not work because "(hello))there" will give ")there"
# E) this does not work for some other reason, but it runs

# let's try "hello.", it return "hello." as intended



##########################################################################
# Q3:

def remove_parentheses (s):
  newWord = ""
  inbrack = False
  for ch in s:
     if ch == "(":
        inbrack = True
  
     if inbrack == False and ch != ")" and ch != "(":
        newWord = newWord + ch
  
     if ch == ")":
        inbrack = False
  return newWord

def remove_parentheses (s):
  newWord = ""
  inbrack = False
  for ch in s:
     if ch == "(":
        inbrack = True
     
     elif ch == ")":
        inbrack = False
     
     else:  # < to make correct, change this to "elif inbrack == False"
        newWord = newWord + ch
  return newWord

# A) both correct but I find the *first* version easier to understand
# B) both correct but I find the *second* version easier to understand
# C) *first* incorrect
# D) *second* incorrect  <



##########################################################################
# Q4:

def remove_parentheses (s):
  new_s = ""
  paren_open = False
  for c in s:
    if c == "(":
      para = True
    elif c == ")" and para == True:
      para = False
    else:
      new_s = new_s + c
  
  return new_s
      
# A) this works as intended
# B) this does not work because ")hello(" will give "hello("
# C) this does not work because "(hello)there" will give "hello"
# D) this does not work because "(hello))there" will give ")there"
# E) incorrect for other reason   <

# let's try "(hello)", should return "", returns "hello" instead



#######################
## UPPER_AFTER_POINT ##
#######################

# My solution

def upper_after_point (s):
  
  # Accumulator
  
  new_s = ""
  
  # Flag that is set to True after encountering a period
  
  upper_next_alpha = True
  
  # (by initializing this flag to True instead of False
  #  we will uppercase the first alphabetical character)
  
  for ch in s:
    if ch.isalpha() and upper_next_alpha == True:
      new_s = new_s + ch.upper()
      upper_next_alpha = False
    else:
      # If the character is a period we set the flag to True
      if ch == '.':
        upper_next_alpha = True
      new_s = new_s + ch
  
  return new_s




#########################
## STUDENT SUBMISSIONS ##
#########################



##########################################################################
# Q5: 

def upper_after_point (s):      
    isfirstalpha = False
    afterperiod = False
    new_word = ""
    for ch in s:
        if ch.isalpha():
            if isfirstalpha == False:
                isfirstalpha= True
                afterperiod = False
                new_word = new_word ch.upper()   # < missing plus
            else:
                if afterperiod:
                    new_word = new_word + ch.upper()
                    afterperiod = False
                else:
                    new_word = new_word + ch
        else:
            if ch == '.':
                afterperiod = True
                new_word = new_word + ch
            else:
                new_word = new_word + ch
    return new_word

# A) this works
# B) this doesn't work  <
# C) this is too complicated


# (the solution works otherwise)



##########################################################################
# Q6:

def upper_after_point (s):
    matching=False
    new=""
    alpha=False
    for pos in range(len(s)):
        
        if s[pos].isalpha()==False and alpha==False:
            new=new+s[pos]
        
        elif s[pos].isalpha()==True and alpha==False:
            alpha=True
            new=new+s[pos].upper()
        
        elif matching==False and alpha==True:
            if s[pos]!=".":
                 new=new+s[pos]
            if s[pos]==".":
                matching =True
                new=new+s[pos]
        
        elif matching==True and alpha==True:
            if s[pos].isalpha()==False:
                new=new+s[pos]
            if s[pos].isalpha()==True:
                new=new+s[pos].upper()
                matching=False
    
    return new

# Q6a: (at the beginning of an iteration) the flag "matching" is:
#
# A) set to True when the *previous* character is a "." and False otherwise <
#
# B) set to True if a "." has been seen at *any* point in the part of the
#    string that has been iterated through at that point, and False if no
#    "." has *ever* be seen - and *only* then
#
# C) set to True if we have uppercased the *previous* character and False
#    otherwise
#
# D) set to True if the current character is an alphabetical character (it
#    has "matched" the alphabetical character test)

def upper_after_point (s):
    matching=False
    new=""
    alpha=False
    for pos in range(len(s)):
        
        if s[pos].isalpha()==False and alpha==False:
            new=new+s[pos]
        
        elif s[pos].isalpha()==True and alpha==False:
            alpha=True
            new=new+s[pos].upper()
        
        elif matching==False and alpha==True:
            if s[pos]!=".":
                 new=new+s[pos]
            if s[pos]==".":
                matching =True
                new=new+s[pos]
        
        elif matching==True and alpha==True:
            if s[pos].isalpha()==False:
                new=new+s[pos]
            if s[pos].isalpha()==True:
                new=new+s[pos].upper()
                matching=False
    
    return new

# Q6b: (at the beginning of an iteration) the flag "alpha" is:
#
# A) set to True when the *current* character is alphabetical
#    and False otherwise  <
#
# B) set to True when *current* character is not alphabetical
#    and False otherwise
# 
# C) set to True if *previous* char was alphabetical; False otherwise
#
# D) set to True if the *current* character is alphabetical and the
#    *previous* one was not (or there was no previous one); and False
#    otherwise

def upper_after_point (s):
    matching=False
    new=""
    alpha=False
    for pos in range(len(s)):
        
        if s[pos].isalpha()==False and alpha==False:
            new=new+s[pos]
        
        elif s[pos].isalpha()==True and alpha==False:
            alpha=True
            new=new+s[pos].upper()
        
        elif matching==False and alpha==True:
            if s[pos]!=".":
                 new=new+s[pos]
            if s[pos]==".":
                matching =True
                new=new+s[pos]
        
        elif matching==True and alpha==True:
            if s[pos].isalpha()==False:
                new=new+s[pos]
            if s[pos].isalpha()==True:
                new=new+s[pos].upper()
                matching=False
    
    return new

# Q6c: this function:
#
# A) uppercases a character if:   <
#       - a character is alphabetical and alpha is set to False
#       - a character is alphabetical and matching is set to True
#
# B) uppercases a character if:
#       - a character is alphabetical and alpha is set to True
#       - a character is alphabetical and matching is set to False
#
# C) uppercases a character if:
#       - a character is alphabetical and alpha is set to True
#       - a character is alphabetical and matching is set to True
#
# D) uppercases a character if:
#       - a character is alphabetical and alpha is set to False
#       - a character is alphabetical and matching is set to False

# Q6d:
#
# A) this function works <
# B) this function does not work
# C) I figured this out ages ago and your questions confused me
# D) I figured this out ages ago and your questions bored me



##########################
## MATCHING_PARENTHESES ##
##########################

# My solution

def matching_parentheses (s):
  # counter that determines how many parentheses are open
  # but not closed
  open_paren_groups = 0
  
  for ch in s:
    # update the counter
    if ch == '(':
      open_paren_groups = open_paren_groups + 1
    elif ch == ')':
      open_paren_groups = open_paren_groups - 1
    
    # check if we have seen more closing than opening
    # which means there is a problem
    if open_paren_groups < 0:
      return False
  
  # at the end, check the counter is 0 and not superior to 0
  if open_paren_groups == 0:
    return True
  else:
    return False



##########################################################################
# Q7:

def matching_parentheses (s):
  counter = 0
  
  for ch in s:
    if ch == '(':
      counter = counter + 1
    elif ch == ')':
      counter = counter - 1
  
  if counter == 0:
    return True
  else:
    return False

# This function does not work and you can see it with the following test:
# (the function called with the test will return something is shouldn't):
#
# A) "(((julia)))"
# B) "()elaine()benes()"
# C) "(old) christine)"
# D) ")selina meyer("
#
# None of those cases will fail, and actually:
#
# E) the function works



##########################################################################
# Q8:

def matching_parentheses (s):
  inside_paren = False
  
  for ch in s:
    if ch == '(':
      inside_paren = True
    elif ch == ')':
      inside_paren = False
  
  return inside_paren

# This function does not work and you can see it with the following test
# (the function called with the test will return something is shouldn't):
#
# A) "(((julia)))"
# B) "()elaine()benes()"
# C) "(old) christine)"
# D) ")selina meyer("
#
# None of those cases will fail, and actually:
#
# E) the function works



##########################################################################
# Q9

def matching_parentheses (s):
  unmatched_paren = 0
  
  for ch in s:
    if ch == '(':
      unmatched_paren = unmatched_paren + 1
    elif ch == ')':
      unmatched_paren = unmatched_paren - 1
    
    if unmatched_paren < 0:
      print False
  
  if unmatched_paren == 0:
    print True
  else:
    print False

# A) the test "(up(up(up-down)down)down)" fails
# B) the test ")jennifer(" fails
# C) the test "(((J-lo)" fails
# D) all those test fail
# E) none of them fail
#
# (again, a test is said to "fail" if the function does not behave as
# expected)



##########################################################################
# Q10:

def matching_parentheses (s):
    peaches=0
    banana=0
    for apple in range(0,len(s)):
        if s[apple]=="(":
            peaches=peaches+1
            banana=banana+1
        if s[apple]==")" and banana >=0:
            peaches=peaches-1
            banana=banana-1
    if s[len(s)- 1]=="(":
       	return False
    if banana==0 and peaches==0:
        return True
    else:
        return False

# A) "peaches" counts the number of opening parentheses and "banana" the
#    the number of closed parentheses
#
# B) "banana" counts the number of opening parentheses and "peaches" the
#    the number of closed parentheses
# 
# C) both "banana" and "peaches" count the same thing: the number of
#    open parentheses that have not yet had a matching closed parenthesis
#
# E) this guy was on crack (I doubt it was a girl, they are usually more
#    sensible, but I guess it could be) 



##########################################################################
##########################################################################


##########################################################################
# Q11

def myfunc1(s, x):
  myvar = 0
  for i in range(len(s)):
    if s[i] == x:
      myvar = myvar + 1
  return myvar


# Q11a:
#
# (numerical) What does myfunc1("test", "t") return?

# Q11b:
#
# (numerical) What does myfunc1("test", "e") return?

# Q11c:
#
# (numerical) What does myfunc1("test", "z") return?

# Q11c:
#
# A) this function returns the sum of the positions at which the character
#    x is found in the string s
#
# B) if the character x appears in s, this function returns the position
#    of the first occurrence
#
# C) this function returns the number of times x occurs in s
#
# D) this functions does something else
#
# E) this function does has a syntaxical error



##########################################################################
# Q12

def myfunc2(s, x):
  flag = False
  myvar = 0
  for i in range(len(s)):
    if s[i] == x:
      flag = True
    elif flag == False:
      myvar = myvar + 1
  return myvar

# Q12a:
#
# (numerical) What does myfunc2("test", "t") return?

# Q12b:
#
# (numerical) What does myfunc1("test", "e") return?

# Q12c:
#
# (numerical) What does myfunc1("test", "z") return?

# Q12d:
#
# A) this function returns the sum of the positions at which the character
#    x is found in the string s
#
# B) if the character x appears in s, this function returns the position
#    of the first occurrence
#
# C) this function returns the number of times x occurs in s
#
# D) this functions does something else
#
# E) this function does has a syntaxical error



    

    
